package com.vitorventurin.gps;

import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaPlugin;
import org.json.JSONArray;
import org.json.JSONException;

import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.widget.Toast;


public class GPS extends CordovaPlugin implements LocationListener {
    private LocationManager locationManagerG;
    private LocationManager locationManagerN;
    Location locationG;
    Location locationN;
    private double lat=0;
    private double lng=0;

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        
        long maximumAge=300000;
        locationManagerG = (LocationManager) this.webView.getContext().getSystemService(Context.LOCATION_SERVICE);
        
        if (action.equals("escrever")) {
            
            locationG = locationManagerG.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
            
            if (locationG != null && (locationG.getTime() + maximumAge) > new java.util.Date().getTime())
            {
                this.lat = locationG.getLatitude();
                this.lng = locationG.getLongitude();
            }
            if (this.lat == 0)
            {
                locationG = locationManagerG.getLastKnownLocation(LocationManager.GPS_PROVIDER);

                if (locationG != null && (locationG.getTime() + maximumAge) > new java.util.Date().getTime())
                {
                    this.lat = locationG.getLatitude();
                    this.lng = locationG.getLongitude();
                }
            }

            
            Bundle bundle = new Bundle();
            locationManagerG.sendExtraCommand("gps", "delete_aiding_data",null);
            locationManagerG.sendExtraCommand("gps", "force_xtra_injection", bundle);
            locationManagerG.sendExtraCommand("gps", "force_time_injection", bundle);

            locationManagerG.requestLocationUpdates(LocationManager.GPS_PROVIDER,1800000, 10, this);
            locationManagerG.requestLocationUpdates(LocationManager.NETWORK_PROVIDER,1800000, 10, this);

            JSONArray obj = new JSONArray();
            obj.put(this.lat);
            obj.put(this.lng);
            
            if (obj != null && obj.length() > 0) {
                callbackContext.success(obj);
            } else {
                callbackContext.error("Expected one non-empty string argument.");
            }
            
            return true;
        }
        
        if (action.equals("getCache")) {
            
            locationG = locationManagerG.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
            
            if (locationG != null && (locationG.getTime() + maximumAge) > new java.util.Date().getTime())
            {
                this.lat = locationG.getLatitude();
                this.lng = locationG.getLongitude();
            }
            if (this.lat == 0)
            {
                locationG = locationManagerG.getLastKnownLocation(LocationManager.GPS_PROVIDER);

                if (locationG != null && (locationG.getTime() + maximumAge) > new java.util.Date().getTime())
                {
                    this.lat = locationG.getLatitude();
                    this.lng = locationG.getLongitude();
                }
            }
            

            JSONArray obj1 = new JSONArray();
            obj1.put(this.lat);
            obj1.put(this.lng);

            if (obj1 != null && obj1.length() > 0) {
                callbackContext.success(obj1);
            } else {
                callbackContext.error("Expected one non-empty string argument.");
            }
            
            return true;
        }

        if (action.equals("getLastCache")) {
            
            locationG = locationManagerG.getLastKnownLocation(LocationManager.GPS_PROVIDER);

            this.lat = locationG.getLatitude();
            this.lng = locationG.getLongitude();

            
            if (this.lat == 0)
            {
                locationG = locationManagerG.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);

                this.lat = locationG.getLatitude();
                this.lng = locationG.getLongitude();
            }
        
            if (this.lat == 0)
            {
                locationG = locationManagerG.getLastKnownLocation(LocationManager.PASSIVE_PROVIDER);

                this.lat = locationG.getLatitude();
                this.lng = locationG.getLongitude();
            }
                    
            
            JSONArray obj1 = new JSONArray();
            obj1.put(this.lat);
            obj1.put(this.lng);

            if (obj1 != null && obj1.length() > 0) {
                callbackContext.success(obj1);
            } else {
                callbackContext.error("Expected one non-empty string argument.");
            }
            
            return true;
        }
        
        
        return false;
    }

    @Override
    public void onLocationChanged(Location location) {
        this.lat = location.getLatitude();
        this.lng = location.getLongitude();
    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onProviderEnabled(String provider) {
        Toast.makeText(this.webView.getContext(), "Gps turned on ", Toast.LENGTH_LONG).show();
    }

    @Override
    public void onProviderDisabled(String provider) {
        Toast.makeText(this.webView.getContext(), "Gps turned off ", Toast.LENGTH_LONG).show(); 
    }
}